//  ** Revision History **
//  14-Jan-1993 (AH) Release 1.0.0.000
//  20-Dec-1992 (AH) Problems with AutoSizeChild fixed. Enumuration removed use PARENTNOTIFY instead!
//  20-Dec-1992 (AH) Changed dimensions for autosize control so it fits ok in inner window
//  14-Oct-1992 (AH) Problem with inner- Outer borders fixed
//  14-Oct-1992 (AH) Colorbar added
//  03-Jul-1992 (AH) About box added
//  22-Jun-1992 (AH) Flyttat till PWB

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         frame.c  (part of EuroCtrl project)
//   
// PURPOSE:      Make a Ownerdrawn Groupbox
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "esframe.h"              


#include "version.h"
#include <string.h>
#define  CTL_DATA       // To declare static data in frame.h
#include "frame.h"
#include "vb1.h"		// Support for VB 1.0
#include "vb2.h"		// Support for VB 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;     
extern USHORT	VBVersion;
HWND	gChildhWnd;			// handle to child window
HANDLE  ghWndFrame;

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawFrame(HCTL hctl, HWND hWnd, HDC hDC);
VOID NEAR RecalcAreaFrame(HCTL hctl, HWND hWnd);
VOID NEAR AutoSizeChild(HCTL hctl, BOOL fredraw);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export FrameCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Frame Control Procedure     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

LONG FAR PASCAL _export FrameCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PFRAME      pframe;
    
    // Message pre-processing
    switch (msg) { 
        case WM_CREATE:   
            gChildhWnd = 0;				// no child yet!
            pframe = FRAMEDEREF(hctl);
            pframe->Look3D = TRUE;
            pframe->BorderWidth = 0; 
            pframe->InnerStyle = BORDERSTYLECARVED;
            pframe->OuterStyle = BORDERSTYLECARVED;
            pframe->Light3DColor = WHITE;
            pframe->Dark3DColor = DARKGREY;
            pframe->BorderColor = BLACK;
            pframe->AlignHoriz=HALIGNCENTER;
            pframe->Font3D=FONT3DNORMAL;
            pframe->DrawStyle = FRAMEDRAWSTYLELINE;
            pframe->CaptionStyle= FRAMECAPTIONSTYLENORMAL;

#ifndef RUNTIMEVERSION                           
            // set the property text for the About dialog
            SetAboutText(hctl, IPROP_FRAME_ABOUT);                                       
#endif            
            
            VBSetControlProperty(hctl, IPROP_FRAME_BACKCOLOR, 
                                       FRAME_BACKGROUND_DEFAULT);
        break;

        
#ifndef RUNTIMEVERSION    
		case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_FRAME_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_FRAME_ALIGNHORIZ:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_aligntexthoriz);
			    		return 0L;                                                        
                
                	case IPROP_FRAME_AUTOSIZECHILD:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_autosizechild);
			    		return 0L; 
            	
                	case IPROP_FRAME_BORDERCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_bordercolor);
			    		return 0L;                                            
            
            		case IPROP_FRAME_BORDERWIDTH:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_borderwidth);
			    		return 0L;                                            
            
            		case IPROP_FRAME_CAPTIONSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_captionstyle);
			    		return 0L;                                            
            
            		case IPROP_FRAME_DARK3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_dark3dcolor);
			    		return 0L;                                            
            
            		case IPROP_FRAME_DRAWSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_drawstyle);
			    		return 0L;                                            
            
            		case IPROP_FRAME_FONT3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_font3d);
			    		return 0L;                                       
            
            		case IPROP_FRAME_LIGHT3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_light3dcolor);
			    		return 0L;                                             
            
                	case IPROP_FRAME_LOOK3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_look3d);
			    		return 0L;                                             
                        
            		case IPROP_FRAME_OUTERSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_outerstyle);
			    		return 0L;                                             
                    
                    case IPROP_FRAME_INNERSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_innerstyle);
			    		return 0L; 
                        
            		case IPROP_FRAME_PICTUREBACK:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturebackground);
			    		return 0L;                                                
                    
                	case IPROP_FRAME_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                             
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esframe);;
		    return 0L;
		}
		break;                  
        
        case VBM_INITPROPPOPUP:
        	switch (wp) 
            {
	    		case IPROP_FRAME_ABOUT:
        			hctlDialog  = hctl;
            		ipropDialog = wp;
            		return (LONG)HwndInitAboutPopup(); 
                                     
        		case IPROP_FRAME_BORDERCOLOR:
        		case IPROP_FRAME_DARK3DCOLOR:
        		case IPROP_FRAME_LIGHT3DCOLOR:
            		if (VBVersion < 0x0200) 
                    {
            			hctlDialog  = hctl;
            			ipropDialog = wp;
            			return (LONG)HwndInitColorPopup();
        			}
        	}
        	break; 

#endif        
                
        case WM_RBUTTONDBLCLK: 
            if (VBGetMode() == MODE_DESIGN) {
            	WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esframe);
            	return OK;
            }
            else
                break;
        
        case WM_ERASEBKGND: 
            AutoSizeChild(hctl, TRUE);              
        	return TRUE;
        
        case WM_PARENTNOTIFY:
            pframe = FRAMEDEREF(hctl);
        		switch (wp) {
                case WM_CREATE:
                	if (!gChildhWnd) 
                    {    
                		gChildhWnd = LOWORD(lp); 
                		PostMessage(hWnd, WM_SIZE, 0, 0L);
                    }
                  	break;
                
                case WM_DESTROY:                
                    gChildhWnd = 0;
                   	break;
                
                case WM_LBUTTONDOWN:
                    AutoSizeChild(hctl, TRUE);
        		}
        	return OK;
        
        case WM_SETFONT:
            pframe = FRAMEDEREF(hctl);
            pframe->hfont = (HFONT)wp;
            return(0L);

        case WM_GETFONT:
            pframe = FRAMEDEREF(hctl);
            return (pframe->hfont);

        case WM_SETTEXT: {
            HSZ hsz;

            pframe = FRAMEDEREF(hctl);
            if (pframe->hszCaption) {
                VBDestroyHsz(pframe->hszCaption);
            }
            hsz = VBCreateHsz((_segment)hctl, (LPSTR)lp);
            pframe = FRAMEDEREF(hctl);
            pframe->hszCaption = hsz;
            pframe->CaptionLen=lstrlen(VBDerefHsz(pframe->hszCaption));
            InvalidateRect(hWnd, NULL, TRUE);
            return(0L);
        }
     
        case WM_GETTEXT: 
        {    
            LPSTR   lpstr;
            WORD    cch;

            pframe = FRAMEDEREF(hctl);
            if (pframe->hszCaption == NULL) 
            {
                *(LPSTR)lp = 0L;
                wp = 1;
            }
            else 
            {
                lpstr = VBDerefHsz(pframe->hszCaption);
                cch = lstrlen(lpstr) + 1;
                if (wp > cch)
                    wp = cch;
                _fstrncpy((LPSTR)lp, lpstr, wp);
                ((LPSTR)lp)[wp - 1] = '\0';
            }
        }
        return (LONG)(wp - 1);

        case WM_GETTEXTLENGTH:
            pframe = FRAMEDEREF(hctl);
            if (pframe->hszCaption == NULL) 
            {
                pframe->CaptionLen=0;
                return(0L);
            }    
            else
                return (pframe->CaptionLen=lstrlen(VBDerefHsz(pframe->hszCaption)));    
                
        case WM_SIZE:
            RecalcAreaFrame(hctl, hWnd); 
        	InvalidateRect(hWnd,NULL, TRUE);
            AutoSizeChild(hctl, TRUE);
            break;
            
        case WM_PAINT: 
            if (wp)
                DrawFrame(hctl, hWnd, (HDC)(wp));
            else 
            {
                PAINTSTRUCT     ps;

                BeginPaint(hWnd, &ps);
                DrawFrame(hctl, hWnd, ps.hdc);
                EndPaint(hWnd, &ps);
            }
            break;
            
        case VBM_SETPROPERTY:
            switch (wp) 
            {
                case IPROP_FRAME_CAPTION:
                    // To avoid a Windows problem, make sure text is
                    // under 255 bytes:
                    if (lstrlen((LPSTR)lp) > 255)
                        *((LPSTR)lp + 255) = 0;
                    break;
                
                case IPROP_FRAME_LOOK3D:
                case IPROP_FRAME_BORDERWIDTH:
                case IPROP_FRAME_LIGHT3DCOLOR:
                case IPROP_FRAME_DARK3DCOLOR:
                case IPROP_FRAME_BORDERCOLOR:
                case IPROP_FRAME_ALIGNHORIZ:
                case IPROP_FRAME_FONT3D:
                case IPROP_FRAME_INNERSTYLE:
                case IPROP_FRAME_OUTERSTYLE:           
                case IPROP_FRAME_DRAWSTYLE:            
                case IPROP_FRAME_CAPTIONSTYLE:    
                    RecalcAreaFrame(hctl, hWnd);
                    InvalidateRect(hWnd, NULL, TRUE);
                    return(0L);              
                
                case IPROP_FRAME_AUTOSIZECHILD: 
                {
                    pframe = FRAMEDEREF(hctl);
                    if (pframe->AutoSizeChild) 
                    {
                    	RecalcAreaFrame(hctl, hWnd);
                    	InvalidateRect(hWnd, NULL, TRUE);
                    	AutoSizeChild(hctl, TRUE);
                    }
                    return(0L);                        
            	}
            }
            break;
        
        
        case VBM_CHECKPROPERTY:
            switch (wp) 
            {
                case IPROP_FRAME_PICTUREBACK: 
                {
                    PIC pic;

                    VBGetPic((HPIC)lp, &pic);
                    switch (pic.picType) 
                    {
                        case PICTYPE_NONE:
                        case PICTYPE_BITMAP:
                            InvalidateRect(hWnd, NULL, TRUE);
                            return ERR_None;
                    }
                return ERR_InvPropVal;
                }
            }
            break;
              
    	case VBM_GETPROPERTY: 
    	{
			if (wp == IPROP_FRAME_HWND) 
			{ 
				ghWndFrame = VBGetControlHwnd(hctl);
				(HWND *)lp = &ghWndFrame; 
				return OK;
			}   
			break; 
    	}    
    }                       
    
    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) 
    {
        case WM_DESTROY:
            VBFreePic(FRAMEDEREF(hctl)->hpicBack);
            break;
    }
    return lResult;
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawFrame(HCTL hctl, HWND hWnd, HDC hDC)       
//
//      PURPOSE:    Draw the Frame     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawFrame(HCTL hctl, HWND hWnd, HDC hDC)
{
    PFRAME  pframe = FRAMEDEREF(hctl);
    HPIC    hpic;
    PIC     pic;
    BITMAP  bmp;
    HANDLE  hBrush;
    HANDLE  hBrush3DLight,hBrush3DDark;
    HANDLE  hBrushBorder;
    HANDLE  hPenLight;      
    HANDLE  hPenDark;       
    HANDLE  hOldBrush = NULL;      
    HANDLE  hOldPen = NULL;
    RECT	rectALL;

    // Fetch Backgroundpicture
    hpic = pframe->hpicBack;
    VBGetPic(hpic, &pic);
    
    // Fetch Background Brush
    hBrush = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hDC, MAKELONG(hWnd, 0));
    
    // get the clientarea
    GetClientRect(hWnd, &rectALL);
    
    //Fill Background
    FillRect(hDC, &rectALL, hBrush);
    
    //create pens                             
    hPenLight  = CreatePen(PS_SOLID,1, RGBCOLOR(pframe->Light3DColor)); 
    hPenDark   = CreatePen(PS_SOLID,1, RGBCOLOR(pframe->Dark3DColor));
    
    // create brush's 
    hBrush3DLight = CreateSolidBrush(RGBCOLOR(pframe->Light3DColor));
    hBrush3DDark  = CreateSolidBrush(RGBCOLOR(pframe->Dark3DColor));
    hBrushBorder = CreateSolidBrush(RGBCOLOR(pframe->BorderColor));
    
    // Select new Pen & Brush
    hOldPen = SelectObject(hDC, hPenLight);
    hOldBrush = SelectObject(hDC, hBrush3DLight);
    
    switch(pic.picType) 
    {
        case PICTYPE_BITMAP: 
        { 
            HBRUSH 	hPattBrush;
        	HBRUSH  hbrOld;
            
            GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
            hPattBrush = CreatePatternBrush(pic.picData.bmp.hbitmap);
            UnrealizeObject(hPattBrush);
            hbrOld = SelectObject(hDC, hPattBrush);
            PatBlt(hDC, 0, 0,
            	rectALL.right-rectALL.left,
            	rectALL.bottom-rectALL.top,
            	PATCOPY);
         	SelectObject(hDC, hbrOld);
         	DeleteObject(hPattBrush);
         	break;
         }
         
         case PICTYPE_NONE: 
         {
            // Just fill background color
            //FillRect(hDC, &pframe->rectDrawInto, hBrush);
            break;
         }
    }
    if (pframe->BorderWidth) 
    {
    	switch(pframe->InnerStyle) 
    	{
        	case BORDERSTYLENORMAL:
            	FrameRect(hDC, &pframe->rect3D, hBrushBorder);
            	break; 
        
        	case BORDERSTYLECARVED:
            	if (pframe->DrawStyle == FRAMEDRAWSTYLELINE) 
            	{
            		FrameRect(hDC, &pframe->rectUpper, hBrush3DDark);
            		FrameRect(hDC, &pframe->rectLower, hBrush3DLight);
            		//FrameRect(hDC, &pframe->rect3D, hBrushBorder);
            	}
        		else 
            	{
                	DrawButton(hDC, &pframe->rect3D, pframe->Dark3DColor, pframe->Light3DColor);
            	}    
            	break;
        
        	case BORDERSTYLERAISED:
            	if (pframe->DrawStyle == FRAMEDRAWSTYLELINE) 
            	{
            		FrameRect(hDC, &pframe->rectUpper, hBrush3DLight);
            		FrameRect(hDC, &pframe->rectLower, hBrush3DDark);
            		//FrameRect(hDC, &pframe->rect3D, hBrushBorder);
            	}
        		else 
            	{
                	DrawButton(hDC, &pframe->rect3D, pframe->Light3DColor, pframe->Dark3DColor);
            	}    
            	break;      
    	}               
	}
	                 
    switch(pframe->OuterStyle) 
    {
    	case BORDERSTYLENORMAL:
        	FrameRect(hDC, &rectALL, hBrushBorder);
            break;   
            
        case BORDERSTYLECARVED:
           	if (pframe->DrawStyle == FRAMEDRAWSTYLELINE) 
            {
            	FrameRect(hDC, &pframe->rectOUpper, hBrush3DDark);
            	FrameRect(hDC, &pframe->rectOLower, hBrush3DLight);
            	//FrameRect(hDC, &rectALL, hBrushBorder);
            }
            else 
            {
                DrawButton(hDC, &rectALL, pframe->Dark3DColor, pframe->Light3DColor);
            }    
            break;
            
        case BORDERSTYLERAISED: 
            if (pframe->DrawStyle == FRAMEDRAWSTYLELINE)
            {
            	FrameRect(hDC, &pframe->rectOUpper, hBrush3DLight);
            	FrameRect(hDC, &pframe->rectOLower, hBrush3DDark);
            	//FrameRect(hDC, &rectALL, hBrushBorder);
            }
            else                 
            {
                DrawButton(hDC, &rectALL, pframe->Light3DColor, pframe->Dark3DColor);
            }    
           	break;      
   	}       

    // Draw Captiontext if it should be Displayed
    if (pframe->CaptionLen != 0) 
    {
        RECT	rectInner;
        char    hszbuf[258];
        LPSTR   p=hszbuf;      
        HFONT	hOldFont;
        
        hOldFont = SelectObject(hDC, pframe->hfont);                  
        // copy rect3D to inner rect and inflate it
        CopyRect(&rectInner, &pframe->rect3D);
        InflateRect(&rectInner, -1, -2);
        
        hszbuf[0]=0x20;
        lstrcpy((LPSTR)(hszbuf+1), VBDerefHsz(pframe->hszCaption));
        pframe = FRAMEDEREF(hctl);
        hszbuf[pframe->CaptionLen+1] = 0x20;
        hszbuf[pframe->CaptionLen+2] = 0x00;
        SelectObject(hDC, hBrush);
        
        switch(pframe->CaptionStyle) 
        {
            case FRAMECAPTIONSTYLENORMAL:
        		// Draw one extra time to erase part of line
        		DrawText(hDC, hszbuf, -1, &pframe->rectCaption, (pframe->AlignHoriz | DT_TOP | DT_SINGLELINE));
        		DrawFont3D(hDC, hszbuf, &pframe->rectCaption, 
                    (pframe->AlignHoriz | DT_TOP | DT_SINGLELINE), pframe->Font3D, 
                    TRANSPARENT, GetTextColor(hDC));
    			break; 
            
    		case FRAMECAPTIONSTYLENONE:
                break;     
            
            case FRAMECAPTIONSTYLETOP:
                DrawFont3D(hDC, hszbuf, &rectInner, 
                    (pframe->AlignHoriz | DT_TOP | DT_SINGLELINE), pframe->Font3D, 
                    TRANSPARENT, GetTextColor(hDC)); 
                break;                        
            
            case FRAMECAPTIONSTYLEMIDDLE:
                DrawFont3D(hDC, hszbuf, &rectInner, 
                    (pframe->AlignHoriz | DT_VCENTER | DT_SINGLELINE), pframe->Font3D, 
                    TRANSPARENT, GetTextColor(hDC)); 
                break;
            
            case FRAMECAPTIONSTYLEBOTTOM:
                DrawFont3D(hDC, hszbuf, &rectInner, 
                    (pframe->AlignHoriz | DT_BOTTOM | DT_SINGLELINE), pframe->Font3D, 
                    TRANSPARENT, GetTextColor(hDC)); 
                break;
       } 
       SelectObject(hDC, hOldFont);    
    } 
    // Restore old objects
    SelectObject(hDC, hOldBrush); 
    SelectObject(hDC, hOldPen);  
    
    // no need to delete hBrush (VB rescurce)
    DeleteObject(hPenLight);
    DeleteObject(hPenDark);
    DeleteObject(hBrush3DLight);
    DeleteObject(hBrush3DDark);   
    DeleteObject(hBrushBorder);   
}

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaFrame(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the framepicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920526AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaFrame(HCTL hctl, HWND hWnd)
{
    PFRAME   pframe = FRAMEDEREF(hctl);
    LPRECT  prectframe = &pframe->rectDrawInto;
    LPRECT  rect3D = &pframe->rect3D;
    LPRECT  rectText = &pframe->rectCaption;
    LPRECT  rectUpper = &pframe->rectUpper;
    LPRECT  rectLower = &pframe->rectLower;
    LPRECT  rectOUpper = &pframe->rectOUpper;
    LPRECT  rectOLower = &pframe->rectOLower;
    RECT    rectALL;
    int		topdown;
    
    // get the clientarea
    GetClientRect(hWnd, &rectALL);
    
    // no extra space at top if there is a border                
    if (pframe->BorderWidth || pframe->AutoSizeChild)
        topdown = 0;
    else
        topdown = 5;
    
    // calculate the window to display button picture in 
    prectframe->left   = rectALL.left+pframe->BorderWidth;
    prectframe->right  = rectALL.right-pframe->BorderWidth;
    prectframe->bottom = rectALL.bottom-pframe->BorderWidth;
    prectframe->top    = rectALL.top+pframe->BorderWidth;
    
    // calculate the 3D rectangle
    rect3D->left    = prectframe->left+1;
    rect3D->right   = prectframe->right-1;
    rect3D->bottom  = prectframe->bottom-1;
    rect3D->top     = prectframe->top+topdown+1;
    
    // calculate the Upper inner rectangle
    rectUpper->left    = rect3D->left;
    rectUpper->right   = rect3D->right-1;
    rectUpper->bottom  = rect3D->bottom-1;
    rectUpper->top     = rect3D->top;  
    
    // calculate the Lower inner rectangle
    rectLower->left    = rect3D->left+1;
    rectLower->right   = rect3D->right;
    rectLower->bottom  = rect3D->bottom;
    rectLower->top     = rect3D->top+1; 
    
    // calculate the Outer Upper 3D rectangle
    rectOUpper->left    = rectALL.left;
    rectOUpper->right   = rectALL.right-1;
    rectOUpper->bottom  = rectALL.bottom-1;
    rectOUpper->top     = rectALL.top;  
    
    // calculate the Outer Lower rectangle
    rectOLower->left    = rectALL.left+1;
    rectOLower->right   = rectALL.right;
    rectOLower->bottom  = rectALL.bottom;
    rectOLower->top     = rectALL.top+1; 
    
    // calculate the Text rectangle
    rectText->left    = prectframe->left+8;
    rectText->right   = prectframe->right-8;
    rectText->bottom  = prectframe->bottom;
    rectText->top     = prectframe->top+2; 
	
	if (pframe->BorderWidth)
    	rectText->top = rectUpper->top+2;   
}    

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR AutoSizeChild(HWND hWnd, BOOL fredraw)       
//
//      PURPOSE:    Send a message to the childs in the groupbox and
//                  give it a message to resize itself.
//
//      COMMENTS:   
//   
//**************************************************************************

VOID NEAR AutoSizeChild(HCTL hctl, BOOL fredraw)
{                  
    PFRAME   pframe = FRAMEDEREF(hctl);
 	int	dx, dy;
            
    if (pframe->AutoSizeChild && gChildhWnd)
    {
        // calculate desired width and height
        dx = pframe->rect3D.right-pframe->rect3D.left-4;
        dy = pframe->rect3D.bottom-pframe->rect3D.top-4;
        
    	MoveWindow(gChildhWnd,
    			pframe->rect3D.left+2,
    			pframe->rect3D.top+2,
    			dx,
    			dy,
    			fredraw);
	} 
}
