//  ** Revision History **
//  14-Oct-1992 (AH) BorderColor set to NoShow - No function but available in runtime mode.
//****************************************************************************
//                    Copyright (C) 1992 EuroSource AB
//
// FILE:         frame.h
//   
// PURPOSE:      Header file for FRAME subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    



#define FRAME_BACKGROUND_DEFAULT    GREY

//---------------------------------------------------------------------------
// FRAME control data and structs
//---------------------------------------------------------------------------
typedef struct tagFRAME
{                     
    HSZ		hszabout;
    HFONT   hfont;          // CaptionFont
    HSZ     hszCaption;     // handle to Caption String
    SHORT   CaptionLen;     // length of captionstring
    HPIC    hpicBack;       // background picture
    RECT    rectDrawInto;   // interior to work in
    RECT    rect3D;         // Border rectangle
    RECT    rectCaption;    // rectangle to draw Caption in
    RECT    rectUpper;      // Upper 3D rect
    RECT    rectLower;      // Lower 3D rect
    RECT	rectOUpper;		// Upper outer rect
    RECT	rectOLower;		// Lower outer rect
    BOOL    Look3D;         // TRUE if 3D Look
    SHORT   BorderWidth;    // Width of border
    LONG    Light3DColor;   // 3D lines Light Color
    LONG    Dark3DColor;    // 3D Lines Dark Color 
    LONG    BorderColor;    // Color for Border
    ENUM    AlignHoriz;     // Horizontal Alignment
    ENUM    Font3D;         // Select 3D Font type
    ENUM    InnerStyle;     // Carved or Raised;
    ENUM    OuterStyle;     // Carved or Raised;
	ENUM	DrawStyle;		// Line/Button like drawing
	ENUM	CaptionStyle;	// where (and how) to display caption
	BOOL	AutoSizeChild;	// give childwindow same size as rectinner
} FRAME;

typedef FRAME FAR * PFRAME;

#define FRAMEDEREF(hctl)     ((PFRAME)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export FrameCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_FRAME_NAME            0
#define IPROP_FRAME_INDEX           1
#define IPROP_FRAME_PARENT          2
#define IPROP_FRAME_BACKCOLOR       3
#define IPROP_FRAME_LEFT            4
#define IPROP_FRAME_TOP             5
#define IPROP_FRAME_WIDTH           6
#define IPROP_FRAME_HEIGHT          7
#define IPROP_FRAME_ENABLED         8
#define IPROP_FRAME_VISIBLE         9
#define IPROP_FRAME_MOUSEPOINTER    10
#define IPROP_FRAME_CAPTION         11
#define IPROP_FRAME_FONTNAME        12
#define IPROP_FRAME_FONTSIZE        13
#define IPROP_FRAME_FONTBOLD        14
#define IPROP_FRAME_FONTITALIC      15
#define IPROP_FRAME_FONTSTRIKE      16
#define IPROP_FRAME_FONTUNDER       17
#define IPROP_FRAME_DRAG            18
#define IPROP_FRAME_DRAGICON        19
#define IPROP_FRAME_TABINDEX        20
#define IPROP_FRAME_TABSTOP         21
#define IPROP_FRAME_TAG             22
#define IPROP_FRAME_PICTUREBACK     23
#define IPROP_FRAME_LOOK3D          24
#define IPROP_FRAME_BORDERWIDTH     25
#define IPROP_FRAME_LIGHT3DCOLOR    26
#define IPROP_FRAME_DARK3DCOLOR     27
#define IPROP_FRAME_BORDERCOLOR     28
#define IPROP_FRAME_ALIGNHORIZ      29
#define IPROP_FRAME_FONT3D          30
#define IPROP_FRAME_INNERSTYLE     	31
#define IPROP_FRAME_FORECOLOR       32 
#define IPROP_FRAME_ABOUT			33
#define IPROP_FRAME_BORDERSTYLE		34
#define IPROP_FRAME_OUTERSTYLE		35
#define IPROP_FRAME_DRAWSTYLE		36
#define IPROP_FRAME_CAPTIONSTYLE	37
#define IPROP_FRAME_AUTOSIZECHILD	38 
#define IPROP_FRAME_HWND			39

#ifdef CTL_DATA                       

PROPINFO Property_Frame_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(FRAME, hszabout)
}; 

PROPINFO propinfoFramePictureBack =
{
    "PictureBackGround",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(FRAME,hpicBack), 0,
	0
};

PROPINFO propinfoFrameLook3D =
{
    "Look3D",
    DT_BOOL | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,Look3D), 0,
	TRUE
};

PROPINFO propinfoFrameBorderWidth =
{
    "BorderWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,BorderWidth), 0,
	0
};

PROPINFO propinfoFrameLight3DColor =
{
    "Light3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,Light3DColor), 0,
	WHITE
};

PROPINFO propinfoFrameDark3DColor =
{
    "Dark3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,Dark3DColor), 0,
	DARKGREY
};

PROPINFO propinfoFrameBorderColor =
{
    "BorderColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fNoShow | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,BorderColor), 0,
	BLACK
};

PROPINFO propinfoFrameAlignHoriz =
{
    "AlignTextHoriz",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,AlignHoriz), 0,
    HALIGNCENTER,
    "0 - Left.\0"
    "1 - Center.\0"
    "2 - Right.\0",
    HALIGNRIGHT
};

PROPINFO propinfoFrameFont3D =
{
    "Font3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,Font3D), 0,
    FONT3DNORMAL,
    "0 - Normal Text.\0"
    "1 - Carved light.\0"
    "2 - Carved Heavy.\0"
    "3 - Raised light.\0"
    "4 - Raised Heavy.\0",
    FONT3DRAISEDHEAVY
};

PROPINFO propinfoFrameInnerStyle =
{
    "InnerStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,InnerStyle), 0,
    BORDERSTYLECARVED,
    "0 - No 3D effect.\0"
    "1 - Carved.\0"
    "2 - Raised.\0",
    BORDERSTYLERAISED
}; 

PROPINFO propinfoFrameOuterStyle =
{
    "OuterStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,OuterStyle), 0,
    BORDERSTYLECARVED,
    "0 - No 3D effect.\0"
    "1 - Carved.\0"
    "2 - Raised.\0",
    BORDERSTYLERAISED
};

// Drawstyles for Frame
#define FRAMEDRAWSTYLELINE	 0
#define FRAMEDRAWSTYLEBUTTON 1

PROPINFO propinfoFrameDrawStyle =
{
    "DrawStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,DrawStyle), 0,
    FRAMEDRAWSTYLELINE,
    "0 - Lines.\0"
    "1 - Button.\0",
    FRAMEDRAWSTYLEBUTTON
};   

#define	FRAMECAPTIONSTYLENORMAL		0
#define FRAMECAPTIONSTYLENONE		1
#define FRAMECAPTIONSTYLETOP		2
#define FRAMECAPTIONSTYLEMIDDLE		3
#define FRAMECAPTIONSTYLEBOTTOM		4

PROPINFO propinfoFrameCaptionStyle =
{
    "CaptionStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(FRAME,CaptionStyle), 0,
    FRAMECAPTIONSTYLENORMAL,
    "0 - Normal.\0"
    "1 - Dont' display.\0"
    "2 - Inner top.\0"
    "3 - Inner middle.\0"
    "4 - Inner bottom.\0",
    FRAMECAPTIONSTYLEBOTTOM
};
    
PROPINFO propinfoFrameAutoSizeChild =
{
    "AutoSizeChild",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(FRAME,AutoSizeChild), 0,
	FALSE
}; 

PROPINFO propinfoFramehWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};

PPROPINFO proplistFrame[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    &propinfoFramePictureBack,
    &propinfoFrameLook3D,
    &propinfoFrameBorderWidth,
    &propinfoFrameLight3DColor,
    &propinfoFrameDark3DColor,
    &propinfoFrameBorderColor,
    &propinfoFrameAlignHoriz,
    &propinfoFrameFont3D,
    &propinfoFrameInnerStyle,
    PPROPINFO_STD_FORECOLOR,
    &Property_Frame_About,
    PPROPINFO_STD_BORDERSTYLEOFF,
    &propinfoFrameOuterStyle,         
    &propinfoFrameDrawStyle,
    &propinfoFrameCaptionStyle,
    &propinfoFrameAutoSizeChild,
    &propinfoFramehWnd,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_FRAME_DRAGDROP    0
#define EVENT_FRAME_DRAGOVER    1

#ifdef CTL_DATA
PEVENTINFO eventlistFrame[] =
{
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelFrame =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fChildrenOk,    // MODEL flags
    (PCTLPROC)FrameCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    WS_TABSTOP,     			// Default Window style
    sizeof(FRAME),              // cbCtlExtra for FRAME structure
    IDBMP_FRAME,                // Palette bitmap ID
    "EsFrame",		       		// Default control name
    "EsFrame",		       		// Visual Basic class name
    NULL,                   	// Parent class name
    proplistFrame,              // Properties list
    eventlistFrame,             // Events list
	IPROP_FRAME_CAPTION,		// Default property
	EVENT_FRAME_DRAGDROP,		// Default event
	IPROP_FRAME_CAPTION			// Standrad Property
};
#endif  // CTL_DATA

LPMODEL modellistFrame[] =
    {
    &modelFrame,
    NULL
    };

MODELINFO modelinfoFrame =
    {
    VB_VERSION, 			// VB version being used
    modellistFrame			// MODEL list
    };
#endif  // RC_INVOKED
